#include "dma.h"
#include "keypad.h"
#include "docked.h"

#include "find.h"
#include "commander.h"
#include "eliteloop.h"
#include "chart.h"
#include "galaxy.h"

#include "gfx.h"
#include "text.h"
#include "soup.h"
#include "keyboard.h"
#include "gbahandler.h"


int last_found = 0;
void update_find(void) {
  static int last_index = 0;
  if (last_found < 0) {
    last_found++;
    return;
  }
  if (last_found && last_index == g_keyboard_str_index)
    return;
  last_index = g_keyboard_str_index;
  last_found = 0;
  clear_row(19);
  //vw_print_str("Find?", 1, 19);
  g_xc = 1; g_yc = 19;
  soup2buffer(0xe);
  set_text_x(11);
  vw_print_str(g_keyboard_str, g_xc, 19);
  if (g_keyboard_str_index < 8 && ((game_frames&15) < 10) )
    vw_print_str("_", g_xc, 19);
}


char find_buffer[32]={};
int find_buffer_index = 0;
void handle_letter_find(char l) {
  // add to buffer!
  find_buffer[find_buffer_index++] = l;
  find_buffer[find_buffer_index] = 0;
  find_buffer_index&=0x1f;
}

void find_named_planet(void) {
  if (g_keyboard_str_index == 0)
    return;
  
  // this is so that when we christen the planet, instead
  // of the text going to the screen, it goes to our 
  // find buffer. Then we can compare buffer and player entry
  handle_letter = handle_letter_find;

  seed_t tmp_seed = g_commander.gal_seed;

  int i,j;
  int foundplanet = 0;

  if (last_found>0) {
    for (j = 0; j < last_found; j++) {
      churn_seed(&tmp_seed);
      churn_seed(&tmp_seed);
      churn_seed(&tmp_seed);
      churn_seed(&tmp_seed);
    }
  } else {
    last_found = 0;
  }
  
  for (j = last_found; j < 256; j++) {
    find_buffer_index = 0;
    int mismatch = 0;
    christen_planet(tmp_seed);
    for (i = 0; i < find_buffer_index && i < g_keyboard_str_index; i++) {
      if (g_keyboard_str[i] != find_buffer[i]) {
        mismatch = 1;
        break;
      }
    }
    if (mismatch == 0) {
      // match!
      hyp_seed = tmp_seed;
      hyp_coord.x = tmp_seed.s3;
      hyp_coord.y = tmp_seed.s1;
      foundplanet = 1; 
      break;
    }
    churn_seed(&tmp_seed);
    churn_seed(&tmp_seed);
    churn_seed(&tmp_seed);
    churn_seed(&tmp_seed);
  }
  
  // carry on printing to the screen
  handle_letter = handle_letter_print;
  if (foundplanet) {
    update_cursor();
    snap_to_planet();
    last_found = j+1;
  } else {
    if (last_found==0) {
      // No planets found
      clear_row(19);
      set_text_x(6);
      soup2buffer(0xd7);
    }
    last_found = -20;
  }
}



void find_planet(void) {
  // called when user clicks find planet icon
  // first, should go to galaxy screen, if not already there
  long_scrn();
  // use the last 28 sprites for the virtual keyboard
  // each sprite holds 1 character

  load_vk('?');
  set_vk_callbacks(update_find, find_named_planet, SCR_LONG_CHART);
  //g_find_str_index = 0;
  //g_find_str[g_find_str_index] = 0;
  update_find();
  g_key_handler = virtual_keys;
}



