#ifndef menu_h_seen
#define menu_h_seen

#define MENU_CHANGED 0x80

#define CASH 0xc5
#define SPACE  0xe

typedef int (*MenuFunctionPtr)(int);

extern MenuFunctionPtr g_menu_left_callback;
extern MenuFunctionPtr g_menu_right_callback;
extern MenuFunctionPtr g_menu_a_callback;
extern MenuFunctionPtr g_menu_b_callback;
// 1 or 2, for 2-lines-per-entry menus
extern int g_menu_lines;


void reset_menu(int max, int offset);
void menu_handler(void);
void set_menu_callbacks(
    MenuFunctionPtr right,
    MenuFunctionPtr left,
    MenuFunctionPtr a,
    MenuFunctionPtr b
    );
void menu_msg_timer(void);
void menu_cerror(const char * error);
void menu_error(int which, int message);
int get_menu_selection();
void set_menu_selection(int index);
void enable_menu(int on);

int yes_no_selection(int question,int x, int y); 
#endif
