#ifndef text_h_seen
#define text_h_seen
#include "backgrounds.h"

#define  USE_VARIABLE_WIDTH_FONT 1



//#define FONT_TILE (192+128)
#define FONT_TILE (256)
#define FONT_GLYPHS 96
#define FONT_COL_INDEX 4

#define ALL_CAPS 0
#define LOWER_CASE (0x80|0x40)
#define NAME_CASE (0x80)

#define CHARACTERS (('~' - '!'+3)&~1)
#if USE_VARIABLE_WIDTH_FONT
#define vwfont  _binary_vwfont_raw_start
extern u8  vwfont[];
extern const unsigned char vw_width[CHARACTERS];
#endif


#define LIGHT_YEARS    0xc3
#define LF 0xC
// "intensity" of the colours
#define TEXT_COLVAL 31 

#define TEXT_PAL_RED     2
#define TEXT_PAL_GREEN   (TEXT_PAL_RED + 1)
#define TEXT_PAL_YELLOW  (TEXT_PAL_RED + 2)
#define TEXT_PAL_BLUE    (TEXT_PAL_RED + 3)
#define TEXT_PAL_PURPLE  (TEXT_PAL_RED + 4)
#define TEXT_PAL_CYAN    (TEXT_PAL_RED + 5)
#define TEXT_PAL_WHITE   (TEXT_PAL_RED + 6)
#define TEXT_PAL_GREY   (TEXT_PAL_RED + 7)
#define TEXT_PAL_DARK_GREY  (TEXT_PAL_RED + 8)
#define TEXT_PAL_ORANGE  (TEXT_PAL_RED + 9)

extern int g_xc;
extern int g_yc;
extern int textmod;
extern char g_last_letter;
extern int g_text_palette;
//extern int g_bindex;
extern int g_carry;
extern unsigned char ** g_dictionary;
extern const char * QQ16;
//extern char g_buffer[256];
void text2buffer(int A);
void print_lf(int A);
void print_lf_name(int A);
void print_dots(int A);
// eg 120
void print_number(int value, int sigfig);
// eg 02 or "  2"
void print_number_pad(int value, int sigfig, char gap); 
// eg 63.4
void print_decimal(int value, int);
void int2a(int n, char s[]);

void load_font(void);

void fw_print_char(char text, int x, int y, int pal);
void fw_print_str(const char * const text, int row, int col);
void fw_print_str_pal(char * text, int row, int col,int pal);

void vw_print_str(const char * const text, int row, int col);
void vw_rewind_char(void);
void set_text_x(int x);
void string2buffer(const char * text);

void set_row_pal(int row, int newPalette);
int get_row_pal(int row);
void clear_text(void);
void clear_row(int y);
void centre_str(char * text, int row, int pal);
void print_buffer(int x, int y);
void sprite_text(const char * const text);
int strsize(const char * const text, int * o_len);

typedef void (*LetterHandler)(char);
void handle_letter_print(char);
extern LetterHandler handle_letter;
void style_sheet(int id);
#endif
