
#include "shipdata.h"
#define col_null                     0
#define col_green                    1
#define col_yellow                   2
#define col_white                    3
#define col_cyan                     4  
#define col_grey                     5  
#define col_blue                     6  
#define col_dark_yellow              7  
#define col_red                      8  
#define col_purple                   9  
#define col_dark_red                 10  
#define col_dark_green               11  
#define col_dark_blue                12  
#define col_dark_purple              13  
#define col_dark_cyan                14  
#define col_dark_grey                15

// data for the logo
const vertex_t shiplogo_vertices[42] = {
  {    0,   -9,   55,   31,  { 0,  0,  0,  0} }, // top of triangle
  {  -10,   -9,   30,   31,  { 0,  0,  0,  0} }, // lhs of triangle
  {  -25,   -9,   93,   31,  { 0,  0,  0,  0} }, 
  { -150,   -9,  180,   31,  { 0,  0,  0,  0} }, 
  {  -90,   -9,   10,   31,  { 0,  0,  0,  0} }, 
  { -140,   -9,   10,   31,  { 0,  0,  0,  0} }, 
  {    0,   -9,  -95,   31,  { 0,  0,  0,  0} }, 
  {  140,   -9,   10,   31,  { 0,  0,  0,  0} }, 
  {   90,   -9,   10,   31,  { 0,  0,  0,  0} }, 
  {  150,   -9,  180,   31,  { 0,  0,  0,  0} }, 
  {   25,   -9,   93,   31,  { 0,  0,  0,  0} }, 
  {   10,   -9,   30,   31,  { 0,  0,  0,  0} }, // rhs of triangle
  {  -85,   -9,  -30,   31,  { 2,  0,  3,  3} }, 
  {   85,   -9,  -30,   31,  { 2,  0,  4,  4} }, 
  {  -70,   11,    5,   31,  { 1,  0,  3,  3} }, // 14  to 17 are vertices of logo bg
  {  -70,   11,  -25,   31,  { 2,  0,  3,  3} }, 
  {   70,   11,  -25,   31,  { 2,  0,  4,  4} }, 
  {   70,   11,    5,   31,  { 1,  0,  4,  4} }, // 17 
  {    0,   -9,    5,   31,  { 0,  0,  0,  0} }, // 18 ELITE?
  {    0,   -9,    5,   31,  { 0,  0,  0,  0} }, 
  {    0,   -9,    5,   31,  { 0,  0,  0,  0} }, 
  {  -28,   11,   -2,   31,  { 0,  0,  0,  0} }, // 21
  {  -49,   11,   -2,   31,  { 0,  0,  0,  0} }, // 22
  {  -49,   11,  -10,   31,  { 0,  0,  0,  0} }, 
  {  -49,   11,  -17,   31,  { 0,  0,  0,  0} }, 
  {  -28,   11,  -17,   31,  { 0,  0,  0,  0} }, 
  {  -28,   11,  -10,   31,  { 0,  0,  0,  0} }, 
  {  -24,   11,   -2,   31,  { 0,  0,  0,  0} }, 
  {  -24,   11,  -17,   31,  { 0,  0,  0,  0} }, 
  {   -3,   11,  -17,   31,  { 0,  0,  0,  0} }, 
  {    0,   11,   -2,   31,  { 0,  0,  0,  0} }, 
  {    0,   11,  -17,   31,  { 0,  0,  0,  0} }, 
  {    4,   11,   -2,   31,  { 0,  0,  0,  0} }, 
  {   25,   11,   -2,   31,  { 0,  0,  0,  0} }, 
  {   14,   11,   -2,   31,  { 0,  0,  0,  0} }, 
  {   14,   11,  -17,   31,  { 0,  0,  0,  0} }, 
  {   49,   11,   -2,   31,  { 0,  0,  0,  0} }, 
  {   28,   11,   -2,   31,  { 0,  0,  0,  0} }, 
  {   28,   11,  -10,   31,  { 0,  0,  0,  0} }, 
  {   28,   11,  -17,   31,  { 0,  0,  0,  0} }, 
  {   49,   11,  -17,   31,  { 0,  0,  0,  0} }, 
  {   49,   11,  -10,   31,  { 0,  0,  0,  0} }, 
}; // end of vertices
const line_t shiplogo_lines[37] = {
  { 31,   { 0,  0} , {   0,    1} },
  { 31,   { 0,  0} , {   1,    2} },
  { 31,   { 0,  0} , {   2,    3} },
  { 31,   { 0,  0} , {   3,    4} },
  { 31,   { 0,  0} , {   4,    5} },
  { 31,   { 0,  0} , {   5,    6} },
  { 31,   { 0,  0} , {   6,    7} },
  { 31,   { 0,  0} , {   7,    8} },
  { 31,   { 0,  0} , {   8,    9} },
  { 31,   { 0,  0} , {   9,   10} },
  { 31,   { 0,  0} , {  10,   11} },
  { 31,   { 0,  0} , {  11,    0} },

  { 30,   { 3,  0} , {  14,   15} },
  { 30,   { 1,  0} , {  15,   16} },
  { 30,   { 4,  0} , {  16,   17} },
  { 30,   { 1,  0} , {  17,   14} },
  { 30,   { 3,  0} , {   4,   12} },
  { 30,   { 2,  2} , {  12,   13} },
  { 30,   { 4,  0} , {  13,    8} },
  { 30,   { 1,  1} , {   8,    4} },
  { 30,   { 3,  1} , {   4,   14} },
  { 30,   { 3,  1} , {  12,   15} },
  { 30,   { 4,  2} , {  13,   16} },
  { 30,   { 4,  1} , {   8,   17} },

  { 30,   { 0,  0} , {  21,   22} },
  { 30,   { 0,  0} , {  22,   24} },
  { 30,   { 0,  0} , {  24,   25} },
  { 30,   { 0,  0} , {  23,   26} },
  { 30,   { 0,  0} , {  27,   28} },
  { 30,   { 0,  0} , {  28,   29} },
  { 30,   { 0,  0} , {  30,   31} },
  { 30,   { 0,  0} , {  32,   33} },
  { 30,   { 0,  0} , {  34,   35} },
  { 30,   { 0,  0} , {  36,   37} },
  { 30,   { 0,  0} , {  37,   39} },
  { 30,   { 0,  0} , {  39,   40} },
  { 30,   { 0,  0} , {  41,   38} },
}; // end of lines
const face_t shiplogo_faces[5] = {
  {    0,   23,    0,  31}, 
  {    0,    4,   15,  31}, 
  {    0,   13,  -52,  31}, 
  {  -81,   81,    0,  31}, 
  {   81,   81,    0,  31}, 
}; // end of face norms
const unsigned char shiplogo_polygon0_lines[12] = {
  0,1,2,3,4,5,6,7,8,9,10,11  
};

// the 'nose'
const unsigned char shiplogo_bgpoly0[3] = {
  0,1,11
};

// left wing
const unsigned char shiplogo_bgpoly1[4] = {
  1,2,3,4
};
// right wing
const unsigned char shiplogo_bgpoly2[4] = {
  8,9,10,11
};
// base beneath wings and nose
const unsigned char shiplogo_bgpoly3[4] = {
  1,4,8,11
};

// the bottom triangle 'body'
const unsigned char shiplogo_bgpoly4[3] = {
  5,6,7
};

// the logo back ground
const unsigned char shiplogo_polygon0_2[4] = {
14,15,16,17,
};

// reverse side of logo block
const unsigned char shiplogo_polygon1_lines[4] = {
  4,8,17,14
};
// front face of logo block
const unsigned char shiplogo_polygon2_lines[4] = {
  12,13,16,15
};
// lhs of block
const unsigned char shiplogo_polygon3_lines[4] = {
  15,14,4,12
};
const unsigned char shiplogo_polygon4_lines[4] = {
  17,16,13,8
};

#define LOGO_POLY_CNT 23
#define LOGO_ELITE_ST 24
#define col_logo_letter col_null
const polygon_t shiplogo_polygons[] = {
  // array_ptr,  count, face_norm, vanish_point, colour   
  // the main shield:
  {shiplogo_bgpoly0, 3,  0, 31,  col_yellow},
  {shiplogo_bgpoly1, 4,  0, 31,  col_yellow},
  {shiplogo_bgpoly2, 4,  0, 31,  col_yellow},
  {shiplogo_bgpoly3, 4,  0, 31,  col_yellow},
  {shiplogo_bgpoly4, 3,  0, 31,  col_yellow},
  // the logo bg:
  {shiplogo_polygon0_2 , 4 ,  0, 31,  col_grey},

  // the block the logo sits on
  {shiplogo_polygon1_lines,  4,  1, 31,  col_dark_yellow},
  {shiplogo_polygon2_lines,  4,  2, 31,  col_dark_yellow},
  {shiplogo_polygon3_lines,  4,  3, 31,  col_white},
  {shiplogo_polygon4_lines,  4,  4, 31,  col_dark_grey},

  // the logo lines...
  {shiplogo_lines[LOGO_ELITE_ST].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+1].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+2].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+3].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+4].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+5].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+6].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+7].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+8].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+9].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+10].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+11].vertices, 2, 0, 30, col_logo_letter},
  {shiplogo_lines[LOGO_ELITE_ST+12].vertices, 2, 0, 30, col_logo_letter},

};
const shipheader_t shiplogo = {
  0, // 0  
  9801, // size squ  
  shiplogo_vertices,
  shiplogo_lines,
  shiplogo_faces,
  shiplogo_polygons,
  153, // maxlines  
  0, // maxpoints  
  54, // 7  
  42, // verts  
  37, // lines  
  0, // 10 
  0, // 11 
  5, // faces 
  LOGO_POLY_CNT, // poly_count (default = faces) 
  99, // size 
  252, // enery 
  36, // 15 
  1, // 18 
  0, // laser(5)|missiles(3) 
  
};

