
/*
 * Ship and euqipment updgrades
 * 
 */
#include "screenmode.h"

#include "upgrade.h"
#include "navigation.h"
#include "commander.h"
#include "text.h"
#include "eliteloop.h"
#include "docked.h"
#include "market.h"
#include "menu.h"
#include "soup.h"
#include "soundfx.h"
#include "encyclo.h"


// map equipment to commander.equipment
const static unsigned int equipment_index[] = {
  MISSILES,
  IFF_SYSTEM,
  ECM_SYSTEM,
  FRONT_LASER,
  FRONT_LASER,
  FUEL_SCOOPS,
  ESCAPE_POD,
  HYPERSPACE_UNIT,
  ENERGY_UNIT,
  DOCKING_COMPUTERS,
  GALACTIC_HYPERSPACE,
  FRONT_LASER,
  FRONT_LASER
};


const static unsigned int equip_name[] = {
  0x7c, // all
  0x6b, // iff
  0x6c, // ecm
  0xbb, // laser
  0xbb, // laser
  0x6f, // scoop
  0x70, // pod
  0x71, // hyper unit
  0x72, // energy
  0x73, // dock
  0x74, // gal
  0xbb, // laser
  0xbb, // laser
};

const unsigned short equipment_prices[5][13] = {
// MIS  IFF   ECM   Puls    Beam    scoop  pod    hyp    NRG   dock    gal   milit  mining
 { 250, 4000,  6000,  4000, 10000,  5250,  3000,  5500, 15000, 15000, 50000, 30000,  2500}, // 0   197E
 { 250, 2000,  4000,  2000,  4500,  3750,  2000,  3750, 9000 , 8000 , 30000, 23000,  2500}, // 1a  1998  
 { 250, 4000,  5000,  5000, 10000,  7000,  6000,  4000, 25000, 10000, 40000, 50000,  2500}, // 34  19B2  
 { 250, 3000,  8000,  6000,  8000,  6500,  4500,  8000, 19000, 20000, 60000, 25000,  2500}, // 4e  19CC  
 { 250, 1500,  3000,  3500,  7000,  4500,  2500,  4500, 7000 , 7000 , 30000, 19000,  2500}, // 68  19E6  
};

const player_ship_t player_ship_data[15] = {
// name             price       laser strengths        lsrs  msls  hull  rgen speed cargo  fuel equip  turn    
   {SHPNM_ADDER,        310, {0x0e, 0x8e, 0x92, 0x19}, 0x02, 0x02, 0x04, 0x01, 0x24, 0x09,  60, 0x01, 0xdf},
   {SHPNM_GECKO,        400, {0x0e, 0x8f, 0x93, 0x19}, 0x04, 0x03, 0x05, 0x01, 0x2d, 0x0a,  70, 0x01, 0xef},
   {SHPNM_MORAY,        565, {0x10, 0x8f, 0x96, 0x19}, 0x04, 0x03, 0x06, 0x01, 0x26, 0x0c,  80, 0x04, 0xef},
   {SHPNM_COBRA_MK1,    750, {0x0e, 0x8e, 0x94, 0x19}, 0x04, 0x04, 0x05, 0x01, 0x27, 0x0f,  60, 0x01, 0xcf},
   {SHPNM_IGUANA,      1315, {0x0e, 0x8e, 0x94, 0x19}, 0x04, 0x04, 0x07, 0x01, 0x32, 0x16,  75, 0x00, 0xdf},
   {SHPNM_OPHIDIAN,    1470, {0x0d, 0x8d, 0x90, 0x0c}, 0x01, 0x03, 0x04, 0x01, 0x33, 0x19,  70, 0x04, 0xff},
   {SHPNM_CHAMELEON,   2250, {0x10, 0x8f, 0x97, 0x32}, 0x02, 0x04, 0x08, 0x01, 0x2b, 0x24,  80, 0x04, 0xdf},
   {SHPNM_COBRA_MK3,   2870, {0x12, 0x8f, 0x98, 0x32}, 0x04, 0x05, 0x07, 0x01, 0x2a, 0x2b,  70, 0x00, 0xef},
   {SHPNM_FER_DE_LANCE,3595, {0x12, 0x92, 0x9c, 0x32}, 0x04, 0x04, 0x08, 0x02, 0x2d, 0x0a,  85, 0x02, 0xdf},
   {SHPNM_GHAVIAL,     3795, {0x11, 0x90, 0x99, 0x32}, 0x04, 0x04, 0x09, 0x01, 0x25, 0x38,  80, 0x00, 0xcf},
   {SHPNM_MONITOR,     5855, {0x18, 0x93, 0x9c, 0x32}, 0x04, 0x09, 0x0a, 0x01, 0x18, 0x52, 110, 0x03, 0xbf},
   {SHPNM_PYTHON,      7620, {0x18, 0x92, 0x9b, 0x32}, 0x04, 0x05, 0x0b, 0x01, 0x1e, 0x6b,  80, 0x01, 0xaf},
   {SHPNM_BOA,         9600, {0x14, 0x8e, 0x98, 0x32}, 0x02, 0x07, 0x0a, 0x01, 0x24, 0x85,  90, 0x00, 0xbf},
   {SHPNM_ASP_MK2,    10120, {0x10, 0x91, 0x9f, 0x0c}, 0x01, 0x02, 0x0a, 0x01, 0x3c, 0x07, 125, 0x02, 0xdf},
   {SHPNM_ANACONDA,   18695, {0x1c, 0x90, 0x7f, 0x32}, 0x04, 0x11, 0x0d, 0x01, 0x15, 0xfe, 100, 0x03, 0xaf},

};

void equip_ship(void);
void buy_ship(void);
void sell_ship_equipment(void);

#define EQUIP  0xcf
#define SHIP   0xb9
#define FUEL   0x69
#define PRESENT   0x1f
#define EQUIPMENT   4

void print_ship_name(int i) {
  encyclo2buffer(player_ship_data[i].name);
#if 0
  int j = 0;
  while (player_ship_data[i].name[j]) {
    text2buffer(player_ship_data[i].name[j++]);
  }
#endif
}

int buy_ship_accept(int index) {
  // first of all, can we afford it?
  // get our trade in price
  if (index != g_commander.ship) {
    int trade_in = g_commander.cash + player_ship_data[g_commander.ship].price*1000;
    if ( (player_ship_data[index].price * 1000) <= trade_in) {
      // oof, trade ship
      // full of potential bugs this
      // code based on $4391
      // update cash with trade in cost deducted
      // clear out equipment and clears legal status
      // clears all equipment, missiles, lasers, cargo, special cargo
      // BUT! I think that it is a bug and shouldn't do that
      // at least, shouldn't clear out equipment?
      // the problem with not clearing out equipment is that you
      // could end up with negative space or lasers where they can't go
      int space_used = player_ship_data[g_commander.ship].total_cargo - g_commander.cargo_space;
      if (space_used > player_ship_data[index].total_cargo) {
        // can't downgrade because have bought too much stuff
        menu_error(0,SPACE);
        return 0;
      }
      if (player_ship_data[index].laser_mounts < player_ship_data[g_commander.ship].laser_mounts) {
        // might fudge up lasers
        int i;
        for (i = player_ship_data[index].laser_mounts - 1 ;
            i < player_ship_data[g_commander.ship].laser_mounts; i++) {
          if (g_commander.equipment[i]) {
            menu_error(0xBB,'S');
            return 0;
          }
        }
      }
      // ought to have sold these...
      int i;
      for (i = 0; i < 17; i++) {
        g_commander.cargo[i] = 0;
      }

      g_commander.legal_status = 0;

      // fill in new ship data
      // set fuel tank full
      g_commander.cash = trade_in - (player_ship_data[index].price * 1000);
      g_commander.ship = index;
      g_commander.cargo_space = player_ship_data[index].total_cargo;
      // decrease cargo_space based on equipment fitted
      g_commander.cargo_space -= space_used;
      clear_text();
      buy_ship();

    } else {
      menu_error(0,CASH);
    }
  }
  return 0; 
}

int g_current_ship_submenu = 0;

int buy_ship_submenu_cancel(int index) {
  clear_text();
  buy_ship();
  set_menu_selection(g_current_ship_submenu);
  return 0;
}

void display_showroom(int);
int buy_ship_submenu_accept(int index) {
  if (index == 0) {
    // ship details
    display_showroom(g_current_ship_submenu);
  } else {
    // buy ship
    return buy_ship_accept(g_current_ship_submenu);
  }
  return 0;
}


// we select ship index...
int buy_ship_submenu(int index) {

  g_current_ship_submenu = index;

  // clear out from row x
  int i;
  for (i = 13; i < 17; i++) {
    clear_row(i);
  }

  g_yc = 14;
  set_text_x(4);
  textmod = NAME_CASE;
  soup2buffer(257);
  print_ship_name(index);

  g_yc++;
  set_text_x(4);
  textmod = NAME_CASE;
  text2buffer(EQUIP);
  text2buffer(' ');
  print_ship_name(index);
  set_row_pal(14, TEXT_PAL_WHITE);
  set_row_pal(15, TEXT_PAL_WHITE);

  reset_menu(2, 14);
  set_menu_callbacks(0,0,buy_ship_submenu_accept, buy_ship_submenu_cancel);
  return 0;
}
  
// buying ships $4340 in elitea
void buy_ship(void) {
  g_my_stats.screen = SCR_SHIP;

  g_xc = 11;
  g_yc = 0;
  textmod = ALL_CAPS;
  text2buffer(EQUIP);
  text2buffer(' ');
  print_lf_name(SHIP);
  set_row_pal(0,TEXT_PAL_YELLOW);
  g_yc = 2;

  int ship_count = 0xf - cpl_info.economy*2;
  int i;

#if 0
  // cheatily show all ships
  ship_count = 0xf;
#endif
  for (i = 0; i < ship_count; i++) {
    print_number(i+1, 2);
    text2buffer(' ');
    set_text_x(4);
    // print ship name
    print_ship_name(i);
    set_text_x(15);
    // print price as a large number
    // unlike Beeb version, print the price we pay based on our current ship
    // NOT the "show room" price that a shipless person would pay
    int total = player_ship_data[i].price - player_ship_data[g_commander.ship].price;
    if (total) {
      print_number(total,5);
      // all ships have loads of 0s at the end
      text2buffer('0'); text2buffer('0'); text2buffer('.');print_lf('0');
    } else {
      set_text_x(g_xc+4);
      print_lf('-');
    }
    
  }
  // wait for choice etc
  reset_menu(ship_count, 2);

  // instead of buying, show sub menu with "info, buy"
  //set_menu_callbacks(0,0,buy_ship_accept,0);
  set_menu_callbacks(0,0,buy_ship_submenu,0);
}

int g_equip_index = 0;
void show_new_equipment()
{
  // is called show_new_equipment becuase it used to jump to equipment screen
  // but that was too annoying so I changed it...
  int selection = g_equip_index+1; // offset by 1 due to fuel entry
  clear_text();
  equip_ship();
  set_menu_selection(selection);
  /* int i;
  for (i = 0; i < 60; i++)
    wait_vsync_int();
  manual_activate_screen(SCR_SHOW_EQUIP+1);*/
}
int laser_accept(int view) {
  if (g_commander.equipment[view] ) {
    clear_text();
    equip_ship();
    menu_error(0xbb, PRESENT);
  } else {
    play_sound(SOUNDFX_FIT_LASER);
    int laser = 0;
    if (g_equip_index == 4) {
      laser = 1;
    }
    else if (g_equip_index == 11) {
      laser = 2;
    }
    else if (g_equip_index == 12) {
      laser = 3;
    }
    int laser_strength = player_ship_data[g_commander.ship].laser_strength[laser];
    g_commander.equipment[view] = laser_strength;
    int this_price = equipment_prices[player_ship_data[g_commander.ship].equipment_cost][g_equip_index];
    g_commander.cash -= this_price;
    g_commander.cargo_space--;
    show_new_equipment();
    /*clear_text();
    equip_ship();*/
  }
  return 0;
}
int laser_cancel(int i) {
  clear_text();
  equip_ship();
  set_menu_selection(g_equip_index+1); // offset by 1 due to fuel entry
  return 0;
}

void add_laser(int index) {
  g_equip_index = index; // which laser we buy (for price etc)
  int mounts = player_ship_data[g_commander.ship].laser_mounts;
  int i;
  for (i = 13; i < 17; i++) {
    clear_row(i);
    if ( (i - 13) < mounts) {
      textmod = NAME_CASE;
      g_yc = i;
      set_text_x(4);
      text2buffer(0x60 + (i-13));  // front, rear, left, right
    }
  }
  reset_menu(mounts, 13);
  set_menu_callbacks(0,0,laser_accept, laser_cancel);
}

int g_fuel_price = 0;
int equip_ship_accept(int id) {
  int show_eq_scr = 0;
  if (id == 0) {
    // buy fuel
    if (g_fuel_price && g_commander.cash >= g_fuel_price) {
      play_sound(SOUNDFX_EQUIP_SHIP);
      g_commander.fuel = player_ship_data[g_commander.ship].max_fuel;
      g_commander.cash -= g_fuel_price;
      g_fuel_price = 0;

      clear_text();
      equip_ship();

      /*set_text_x(23);
        g_yc = 3;
        print_decimal(g_fuel_price, 6);*/
    } else if (g_fuel_price) {
      menu_error(0, CASH);
    } else {
      menu_error(0x69, PRESENT);
    }
  } else {
    // buy equipment
    int index = id-1;
    int type = equipment_index[index];
    int this_price = equipment_prices[player_ship_data[g_commander.ship].equipment_cost][index];
    if (g_commander.cash >= this_price) {
      if (type == FRONT_LASER) {
        // a laser...
        int total = get_total_cargo();
        if (total < g_commander.cargo_space) {
          play_sound(SOUNDFX_EQUIP_SHIP);
          add_laser(index);
        } else {
          // space?
          menu_error(0, SPACE);
        }
      } else {
        g_equip_index = index; // store current menu index in case we buy
        if (type == MISSILES) {
          // can we fit them?
          // the way this works is "fit them, then take em off if they don't fit"
          g_commander.equipment[MISSILES]++;
          if (g_commander.equipment[MISSILES] <
              player_ship_data[g_commander.ship].missile_count) 
          {
            play_sound(SOUNDFX_EQUIP_SHIP);
            g_commander.cash -= this_price;
            update_cash();
            show_eq_scr = 1;
          } else {
            // all fitted
            g_commander.equipment[MISSILES]--;
            menu_error(equip_name[index], PRESENT);
          }
        } else {
          // generic equipment
          if ( g_commander.equipment[type] == 0 ) {
            int total = get_total_cargo();
            if (total < g_commander.cargo_space) {
              // buy it
              play_sound(SOUNDFX_EQUIP_SHIP);
              g_commander.cash -= this_price;
              g_commander.equipment[type]++;
              g_commander.cargo_space--;
              show_eq_scr = 1;
              update_cash();
            } else {
              // space?
              menu_error(0, SPACE);
            }
          } else {
            // fitted
            menu_error(equip_name[index], PRESENT);
          }
        }
      }
    } else {
      // cash ?
      menu_error(0, CASH);
    }
  }
  if (show_eq_scr) {
    show_new_equipment();
  }
  return 0;
}

void equip_ship(void) {
  g_my_stats.screen = SCR_EQUIP;
  set_text_x(11);
  g_yc = 0;
  textmod = ALL_CAPS;
  g_text_palette = TEXT_PAL_YELLOW;
  text2buffer(EQUIP);
  text2buffer(' ');
  print_lf_name(SHIP);
  g_yc = 2;
  g_text_palette = TEXT_PAL_WHITE;
  
  // calculate fuel and cost
  // max tech is 14 (onrira) 
  int tek2 = cpl_info.tech+2;
  g_fuel_price = (player_ship_data[g_commander.ship].max_fuel -  g_commander.fuel)*2;

  // bug fix for hi tech planets
  if (tek2 >= 12) 
    tek2 = 0xe;
  
  int i;
  for (i = 0; i < tek2; i++) {
    text2buffer(LF);
    print_number(i+1,2);
    text2buffer(' ');
    text2buffer(FUEL+i);
    unsigned int this_price; 
    if (i != 0) {
      this_price = equipment_prices[player_ship_data[g_commander.ship].equipment_cost][i-1];
    } else {
      this_price = g_fuel_price;
    }
    set_text_x(23);
    print_decimal(this_price, 6);
    if (this_price > g_commander.cash) {
      set_row_pal(g_yc,TEXT_PAL_GREY);
    }
  }
  // wait for choice etc
  // all are straight forward, EXCEPT lasers, which are more hassle
  update_cash();
  reset_menu(tek2, 3);
  set_menu_callbacks(0,0,equip_ship_accept,0);
}

const static int commander_equipment[] = {
  0x60, // FRONT
  0x61,
  0x62,
  0x63,
  0x6B, // I.F.F.SYSTEM
  0x6C, // E.C.M.SYSTEM
  0x6F, // FUEL SCOOPS
  0x70, // ESCAPE POD <- not shown?
  0x71, // HYPERSPACE UNIT
  0x72, // ENERGY UNIT
  0x73, // DOCKING COMPUTERS
  0x74, // GALACTIC HYPERSPACE
};

int commander_to_equip(int comid) {
  if (comid >= 4) {
    int i;
    for (i = 0; i < 13; i++) {
      if (equipment_index[i] == comid)
  return i;
    }
    return i;
  } else {
    int i;
    for (i = 0; i < 4; i++) {
      if (g_commander.equipment[comid] == player_ship_data[g_commander.ship].laser_strength[i]) {
  break;
      }
    }
    //return i;
    int laser = 3;
    switch (i) {
      case 1: laser = 4; break;
      case 2: laser = 11; break;
      case 3: laser = 12; break;
      default: break;
    }
    return laser;
  }
}

void show_equipment(int index, int price) {
  // this is in order of commander data
  text2buffer(commander_equipment[index]);
  if (index < 4) {
    // which laser?
    int i = commander_to_equip(index);
    int laser = 0x67; // PULSE
    switch (i) {
      case 4: laser = 0x68; break;
      case 11: laser = 0x75; break;
      case 12: laser = 0x76; break;
      default :  break;
    }
    text2buffer(' ');
    textmod = NAME_CASE;
    text2buffer(laser);
  } 
  
  if (price) {
    int i = commander_to_equip(index);
    int this_price = equipment_prices[player_ship_data[g_commander.ship].equipment_cost][i];
    set_text_x(22);
    print_decimal(this_price/2, 6);
  } 
  text2buffer(LF);
}

void equipment_screen() 
{
  g_my_stats.screen = SCR_SELL_EQUIP;
  g_yc = 0;
  g_xc = 11;
  textmod = ALL_CAPS;
  custom2buffer(EQUIPMENT);
  set_row_pal(0,TEXT_PAL_YELLOW);
  print_lf(LF);
  textmod = NAME_CASE;

  if (g_commander.equipment[MISSILES]) {
    text2buffer(FUEL+1);
    if (g_commander.equipment[MISSILES]>1) {
      text2buffer('S');
      text2buffer(' ');
      text2buffer('(');
      print_number(g_commander.equipment[MISSILES],0);
      print_lf(')');
    } else {
      text2buffer(LF);
    }
  }
  
  int i;
  for (i = 0; i < MISSILES; i++) {
    if (g_commander.equipment[i]) {
      show_equipment(i,0); // no sell price
    }
  }

}

int sell_equip_accept(int index) {
  int i;
  index += 1;
  int things_to_sell = 0;
  for (i = 0; i < MISSILES; i++) {
    if (g_commander.equipment[i]) {
      things_to_sell++;
      if (things_to_sell == index) {
        // sell item 
        // first ask if we are sure...
        if (yes_no_selection(51,3,15)) {
          int equipid = commander_to_equip(i);
          g_commander.equipment[i] = 0;
          g_commander.cargo_space++;
          int this_price = 
            equipment_prices[player_ship_data[g_commander.ship].equipment_cost][equipid];
          g_commander.cash += this_price/2;
        }
        break;
      }
    }
  }
  clear_text();
  sell_ship_equipment();
  return 0;
}
  
void sell_ship_equipment(void) {
  g_my_stats.screen = SCR_SELL_EQUIP;
  // sell equipment at half price
  int things_to_sell = 0;
  g_yc = 0;
  g_xc = 10;
  textmod = ALL_CAPS;
  text2buffer(0xCD); // SELL
  text2buffer(' ');
  custom2buffer(EQUIPMENT);

  set_row_pal(0,TEXT_PAL_YELLOW);
  print_lf(LF);
  int i;
  textmod = NAME_CASE;
  for (i = 0; i < MISSILES; i++) {
    if (g_commander.equipment[i]) {
      things_to_sell++;
      show_equipment(i,1); // do show sell price
    }
  }
  reset_menu(things_to_sell, 2);
  set_menu_callbacks(0,0,sell_equip_accept,0);
}

