
.section .iwram,"ax",%progbits
.align 4
.code 32
#define   x1   r0
#define   y1   r1
#define   x2   r2
#define   y2   r3


#define deltax r4
#define deltay r5

#define step r6
#define dinc1 r7
#define dinc2 r8
@ recycle r4 r5
#define xinc1 r4
#define xinc2 r5
#define yinc1 r9
#define yinc2 r10
#define numpixels r11
#define bgtd r12

#define   xa   x1
#define   ya   y1
#define   xb   x2
#define   yb   y2

#define tile r4

Lbroken : b Lbroken
.macro mputpixel x y
  @ x y are r0-3
  mov  tile, \x, lsr#3
  add  tile,tile,#1
  mov  r5,\y,lsr#3
  add  tile,tile,r5,lsl#5   @ r0 tile = 1 + (x/8) + ((y/8)*32);
  and  r5,\x,#7
  and  r6,\y,#7
  mov  r7,r5,lsr#2       @ xrem/4
  add  r7,r7,tile,lsl#4  @ tile*16 + xrem/4
  add  r7,r7,r6,lsl#1    @ tile*16 + xrem/4 + yrem*2
  mov  r7,r7,lsl#1      @ gah, have to do this here as halfword instructions can't do shifts

#if 1
@ debugging - make sure we don't write somewhere stange
      add  r6, bgtd, r7
      cmp  r6, #0x06000000
      blt  Lbroken
      sub  r6,r6, #0x06000000
      cmp  r6,#0x0000c000
      bgt  Lbroken
#endif

  ldrh r6,[bgtd,r7]      @pixel  u16 pixel = bg_space.tileData[address];
  and  r5,\x,#3
  mov  r5,r5,lsl #2      @ 0-3 * 4 = shifter 0 to 12
  mov  r4,#0xf  
  bic  r6,r6,r4,lsl r5   @ & 0xFFF0  etc
  @mov  r4,#0x1  
  ldr  r4,lineColour
  orr  r6,r6,r4,lsl r5   @ | 0x0001  etc
  @eor  r6,r6,r4,lsl r5   @ | 0x0001  etc
  
  @ bg_space.tileData[address] = pixel;
  strh r6,[bgtd,r7]      @bg_space.tileData[address] = pixel;
.endm

padding1: .space 12

.arm
.align
.global draw_line
.type draw_line,function
draw_line:
  stmfd   sp!,{r0-r12,lr}
  subs   deltax,x1,x2
  rsbmi  deltax,deltax,#0
  subs   deltay,y1,y2
  rsbmi  deltay,deltay,#0
@ check that dy != 0 and dx != 0
@ as this can lead to over/underflow and "random" writes.
  cmpeq  deltax,#0
  beq    LendLoop1

  cmp    deltax, deltay
  @ if deltax < deltay then swap
  movlt  r6,deltax
  movlt  deltax, deltay
  movlt  deltay, r6
  @ set up counter vars
  add    numpixels,deltax,#2
  mov    dinc1, deltay, lsl#1
  sub    step, dinc1, deltax         @ d = (2 * deltay) - deltax;
  sub    dinc2,dinc1,deltax,lsl#1 @ dinc2 = (deltay - deltax) * 2
  movpl  xinc1 ,#1
  movmi  xinc1 ,#0
  mov    xinc2 ,#1
  movpl  yinc1 ,#0
  movmi  yinc1 ,#1
  mov    yinc2 ,#1
  cmp    x1,x2
  rsbgt  xinc1, xinc1, #0
  rsbgt  xinc2, xinc2, #0
  cmp    y1,y2
  rsbgt  yinc1, yinc1, #0
  rsbgt  yinc2, yinc2, #0


  mov     numpixels,numpixels,lsr#1
  
  ldr     bgtd,=bg_space
  ldr     bgtd,[bgtd,#0]
  @ldr     r4,lineColour
  @ loop over pixel count
.global Lpixels
.type Lpixels,function
Lpixels:
  stmfd sp!,{r4-r7}
  mputpixel  xa ya
  mputpixel  xb yb
  ldmfd sp!,{r4-r7}

  cmp  step, #0
  bpl  Ldpos
  @ d is negative
  add  step,step,dinc1   @ d = d + dinc1;
  add  xa,xa,xinc1 @ xa = xa + xinc1;
  sub  xb,xb,xinc1 @ xb = xb - xinc1;
  add  ya,ya,yinc1 @ ya = ya + yinc1;
  sub  yb,yb,yinc1 @ yb = yb - yinc1;

  subs numpixels, numpixels, #1
  bpl  Lpixels   
  bmi  LendLoop1
Ldpos:
  add  step,step,dinc2   @ d = d + dinc1;
  add  xa,xa,xinc2 @ xa = xa + xinc1;
  sub  xb,xb,xinc2 @ xb = xb - xinc1;
  add  ya,ya,yinc2 @ ya = ya + yinc1;
  sub  yb,yb,yinc2 @ yb = yb - yinc1;

  subs numpixels, numpixels, #1
  bpl  Lpixels   
LendLoop1:
  ldmfd   sp!,{r0-r12,lr}
  bx      lr
  
.global lineColour
lineColour : .space 4

.global put_pixel
.type put_pixel,function
put_pixel:
  stmfd   sp!,{r4-r7,r12}
  ldr     bgtd,=bg_space
  ldr     bgtd,[bgtd,#0]   @ tile address
  mputpixel  x1 y1
  ldmfd   sp!,{r4-r7,r12}
  bx      lr

.global get_pixel
.type put_pixel,function
get_pixel:
  stmfd   sp!,{r12}
  ldr     bgtd,=bg_space
  ldr     bgtd,[bgtd,#0]   @ tile address
  stmfd sp!,{r4-r7}
  mov  tile, x1, lsr#3
  add  tile,tile,#1
  mov  r5,y1,lsr#3
  add  tile,tile,r5,lsl#5   @ r0 tile = 1 + (x/8) + ((y/8)*32);
  and  r5,x1,#7
  and  r6,y1,#7
  mov  r7,r5,lsr#2       @ xrem/4
  add  r7,r7,tile,lsl#4  @ tile*16 + xrem/4
  add  r7,r7,r6,lsl#1    @ tile*16 + xrem/4 + yrem*2
  mov  r7,r7,lsl#1       @ gah
  ldrh r6,[bgtd,r7]      @pixel  u16 pixel = bg_space.tileData[address];
  and  r5,x1,#3
  mov  r5,r5,lsl #2      @ 0-3 * 4 = shifter 0 to 12
  mov  r4,#0xf  
  and  r0,r6,r4,lsl r5   @ & 0xFFF0  etc
  ldmfd sp!,{r4-r7,r12}
  bx    lr

.pool
