.section .iwram,"ax",%progbits
.align 4
.code 32

#define text  r0
#define strw  r1
#define mask  r1
#define vram  r2
#define data  r4
#define shift r5
#define incr  r6
#define incr2  r7
#define incr3  r8
#define cntr   r0
#define upper  r3
#define lower  r9
#define pixpar  r10
#define SPACE 0x20

tmp_text: .space 4
tmp_strw: .space 4

#define vwfont  _binary_vwfont_raw_start
@extern u8  vwfont[];
@extern const unsigned char vw_width[CHARACTERS];

@ this is the same as int vw_print_char(char text, int strw, u16 * vram)
.global vw_print_char_asm
.type vw_print_char_asm, function
vw_print_char_asm:
@ draw text to vram, current (last) string width is strw
@ make vram point to where we are in the string
  stmfd   sp!,{r1-r12}

  @vram += (16*(strw/8));
  @ same as clear low 3 bits, multiply by 2
  bic  data, strw, #7
  add  vram, vram, data, lsl #2   @ *2 and *2 again because vram is a 16 bit pointer

  @u16 * data = (u16*)&vwfont[(text-' ')*32];
  sub text, text, #SPACE
  ldr data, =vwfont
  add data, data, text, lsl #5  @ 32 = lsl 5,  *2 more for 16 bitness  
  
  str text, tmp_text            @ not needed til the end
  str strw, tmp_strw            @ not needed til the end
  @if (strw&7) {
  ands shift,strw, #7
  beq  alignedChar
    @ unaligned write
    @ shift each u16 into a lower u16
    @ int shift = (strw&7);
    @ point vram to base tile
    
    @int incr = 0;
    @int incr2 = 1;
    @int incr3 = 16;
    mov  incr, #0
    mov  incr2, #2
    mov  incr3, #32

    subs   shift,shift, #4      @  shift -= 4;
    @if (shift > 3) {
    @  incr = 1;
    @  incr2 = 16;
    @  incr3 = incr2+1;
    addpl  incr, incr, #2
    addpl  incr2, incr2, #30
    addpl  incr3, incr2, #2
    @ else shift should stay as it is
    addmi  shift, shift, #4

    mov   shift, shift, lsl#2  @shift *= 4;
    mov   cntr, #8
    mov   mask,#0
    sub   mask,mask, #1
 charLine:
    @for (i = 0; i < 8; i++) {
      @u32 lower = *data++;
      @u32 upper = *data++;
      ldrh  lower,[data],#2    @ post incr 2 bytes 
      ldrh  upper,[data],#2    @ post incr 2 bytes 

      @lower = (lower<<shift);   // shift character right "shift" pixels
      mov lower, lower, lsl shift
      @ the upper 4 nibbles contain extra pixels that have overflowed 
      @ these won't be drawn unless we put them in upper
      @upper = (upper<<shift) | (lower>>16);
      mov upper, upper, lsl shift
      orr upper, upper, lower, lsr #16

      @ but uppers top 4 nibbles overflow, store them in carry
      @u32 carry = upper>>16;
      @ this is already there?
      

      @lower &= 0xffff;  // lower contains one lot of pixels
      @upper &= 0xffff;
      
      @u16 pixpar = *(vram+incr);  
      ldrh  pixpar, [vram, incr]   @ load 4 pixels
      @pixpar |= lower;     
      bic  pixpar, pixpar, mask, lsl shift
      orr  pixpar, lower, pixpar  @ mix in low 4 pixels
      @*(vram+incr) = pixpar;
      strh  pixpar, [vram,incr]   @ write back just 4 pixels

      @pixpar = *(vram+incr2);
      ldrh  pixpar, [vram, incr2]   @ load 4 pixels
      @pixpar |= upper;     
      orr  pixpar, upper, pixpar  @ mix in upper 4 pixels
      @*(vram+incr2) = pixpar;
      @ fix for multi coloured tiles
      @strh  pixpar, [vram, incr2]   @ write back 4 pixels
      strh  upper, [vram, incr2]   @ write back 4 pixels
     
      movs   upper, upper, lsr #16
      @if (carry) {
      @ *(vram+incr3) = carry;
      @cmp    upper,#0
      strneh upper, [vram, incr3]   
      @vram += 2;
      add  vram, vram, #4
      subs cntr, cntr, #1
      bne charLine

@ everyone does this bit:
.type finishOff,function
finishOff:
  ldr strw, tmp_strw
  ldr text, tmp_text

  @ strw += vw_width[text-' '];
  ldr   r3, =vw_width  
  ldrb  r3, [r3, text]
  add   r0, strw, r3

  ldmfd   sp!,{r1-r12}

  @return strw;
  bx    lr

  @else 
alignedChar:
    @int i;
    @for (i = 0; i < 8; i++)
    @ *vram++ = *data++;
    @ *vram++ = *data++;
    @ use stmia for this - can load 8 registers with 32 bit values

    @ load the data 
    ldmia data,{text, strw, r5-r10}
    @ store in vram
    stmia vram,{text, strw, r5-r10}
    b finishOff

.pool
.end

