#ifndef modtpes_h_seen
#define modtpes_h_seen

#ifndef GBA_HEADER
typedef unsigned char u8;
typedef signed char s8;
typedef unsigned short u16;
typedef signed short s16;
typedef unsigned long u32;
typedef signed long s32;
#endif

typedef struct 
{
  u16 length;
  u16 loop_start;
  u16 loop_length;
  s8 relative;   // needed? this is == finetune?
  s8 finetune;   // needed? this is == finetune?
  u8 vol;
  u8 pad;
  const s8 * data;  // pointer to data
} sample_t;

typedef struct{
  u32 rows; // 64 for mod, variable for XM
  const u8 * data;          // pattern data 
} pattern_t;

typedef struct 
{
  const pattern_t * pattern;   // i.e. pattern[order[1]].data[index++]  for note, etc
  const sample_t * sample;
  const u8 * order;   // i.e. order[1]
  u16 song_length;
  u8 speed;  // ticks per row (Fxx xx < 0x20)
  u8 tempo;  // BPM           (Fxx xx >= 0x20)
  u8 channels;
} mod_t;
#endif


